package com.siit.wfw.frame.utils;

import com.siit.wfw.frame.utils.DigestStrategy;
import org.bouncycastle.crypto.digests.SM3Digest;
import org.bouncycastle.util.encoders.Hex;

public class SM3Util implements DigestStrategy {

   public static String sm3Hash(byte[] data) {
      SM3Digest sm3Digest = new SM3Digest();
      sm3Digest.update(data, 0, data.length);
      byte[] result = new byte[sm3Digest.getDigestSize()];
      sm3Digest.doFinal(result, 0);
      return Hex.toHexString(result);
   }

   public static String sm3Hash(String str) {
      return sm3Hash((byte[])str.getBytes());
   }

   public static void main(String[] args) {
      String testStr = "Hello, SM3!";
      System.out.println("原文: " + testStr);
      System.out.println("SM3杂凑值: " + sm3Hash((String)testStr));
   }

   public String doEncrypt(String agr1) {
      return sm3Hash((String)agr1);
   }

   public String doEncrypt(byte[] agr1) {
      return sm3Hash((byte[])agr1);
   }
}
